# ory_hydra_client (EXPERIMENTAL)
Documentation for all of Ory Hydra's APIs.


This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v2.0.1
- Build package: org.openapitools.codegen.languages.DartDioClientCodegen

## Requirements

* Dart 2.12.0 or later OR Flutter 1.26.0 or later
* Dio 4.0.0+

## Installation & Usage

### pub.dev
To use the package from [pub.dev](https://pub.dev), please include the following in pubspec.yaml
```yaml
dependencies:
  ory_hydra_client: 2.0.1
```

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```yaml
dependencies:
  ory_hydra_client:
    git:
      url: https://github.com/ory/sdk.git
      #ref: main
```

### Local development
To use the package from your local drive, please include the following in pubspec.yaml
```yaml
dependencies:
  ory_hydra_client:
    path: /path/to/ory_hydra_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:ory_hydra_client/ory_hydra_client.dart';


final api = OryHydraClient().getJwkApi();
final String set_ = set__example; // String | The JSON Web Key Set ID
final CreateJsonWebKeySet createJsonWebKeySet = ; // CreateJsonWebKeySet | 

try {
    final response = await api.createJsonWebKeySet(set_, createJsonWebKeySet);
    print(response);
} catch on DioError (e) {
    print("Exception when calling JwkApi->createJsonWebKeySet: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
[*JwkApi*](doc/JwkApi.md) | [**createJsonWebKeySet**](doc/JwkApi.md#createjsonwebkeyset) | **POST** /admin/keys/{set} | Create JSON Web Key
[*JwkApi*](doc/JwkApi.md) | [**deleteJsonWebKey**](doc/JwkApi.md#deletejsonwebkey) | **DELETE** /admin/keys/{set}/{kid} | Delete JSON Web Key
[*JwkApi*](doc/JwkApi.md) | [**deleteJsonWebKeySet**](doc/JwkApi.md#deletejsonwebkeyset) | **DELETE** /admin/keys/{set} | Delete JSON Web Key Set
[*JwkApi*](doc/JwkApi.md) | [**getJsonWebKey**](doc/JwkApi.md#getjsonwebkey) | **GET** /admin/keys/{set}/{kid} | Get JSON Web Key
[*JwkApi*](doc/JwkApi.md) | [**getJsonWebKeySet**](doc/JwkApi.md#getjsonwebkeyset) | **GET** /admin/keys/{set} | Retrieve a JSON Web Key Set
[*JwkApi*](doc/JwkApi.md) | [**setJsonWebKey**](doc/JwkApi.md#setjsonwebkey) | **PUT** /admin/keys/{set}/{kid} | Set JSON Web Key
[*JwkApi*](doc/JwkApi.md) | [**setJsonWebKeySet**](doc/JwkApi.md#setjsonwebkeyset) | **PUT** /admin/keys/{set} | Update a JSON Web Key Set
[*MetadataApi*](doc/MetadataApi.md) | [**getVersion**](doc/MetadataApi.md#getversion) | **GET** /version | Return Running Software Version.
[*MetadataApi*](doc/MetadataApi.md) | [**isAlive**](doc/MetadataApi.md#isalive) | **GET** /health/alive | Check HTTP Server Status
[*MetadataApi*](doc/MetadataApi.md) | [**isReady**](doc/MetadataApi.md#isready) | **GET** /health/ready | Check HTTP Server and Database Status
[*OAuth2Api*](doc/OAuth2Api.md) | [**acceptOAuth2ConsentRequest**](doc/OAuth2Api.md#acceptoauth2consentrequest) | **PUT** /admin/oauth2/auth/requests/consent/accept | Accept OAuth 2.0 Consent Request
[*OAuth2Api*](doc/OAuth2Api.md) | [**acceptOAuth2LoginRequest**](doc/OAuth2Api.md#acceptoauth2loginrequest) | **PUT** /admin/oauth2/auth/requests/login/accept | Accept OAuth 2.0 Login Request
[*OAuth2Api*](doc/OAuth2Api.md) | [**acceptOAuth2LogoutRequest**](doc/OAuth2Api.md#acceptoauth2logoutrequest) | **PUT** /admin/oauth2/auth/requests/logout/accept | Accept OAuth 2.0 Session Logout Request
[*OAuth2Api*](doc/OAuth2Api.md) | [**createOAuth2Client**](doc/OAuth2Api.md#createoauth2client) | **POST** /admin/clients | Create OAuth 2.0 Client
[*OAuth2Api*](doc/OAuth2Api.md) | [**deleteOAuth2Client**](doc/OAuth2Api.md#deleteoauth2client) | **DELETE** /admin/clients/{id} | Delete OAuth 2.0 Client
[*OAuth2Api*](doc/OAuth2Api.md) | [**deleteOAuth2Token**](doc/OAuth2Api.md#deleteoauth2token) | **DELETE** /admin/oauth2/tokens | Delete OAuth 2.0 Access Tokens from specific OAuth 2.0 Client
[*OAuth2Api*](doc/OAuth2Api.md) | [**deleteTrustedOAuth2JwtGrantIssuer**](doc/OAuth2Api.md#deletetrustedoauth2jwtgrantissuer) | **DELETE** /admin/trust/grants/jwt-bearer/issuers/{id} | Delete Trusted OAuth2 JWT Bearer Grant Type Issuer
[*OAuth2Api*](doc/OAuth2Api.md) | [**getOAuth2Client**](doc/OAuth2Api.md#getoauth2client) | **GET** /admin/clients/{id} | Get an OAuth 2.0 Client
[*OAuth2Api*](doc/OAuth2Api.md) | [**getOAuth2ConsentRequest**](doc/OAuth2Api.md#getoauth2consentrequest) | **GET** /admin/oauth2/auth/requests/consent | Get OAuth 2.0 Consent Request
[*OAuth2Api*](doc/OAuth2Api.md) | [**getOAuth2LoginRequest**](doc/OAuth2Api.md#getoauth2loginrequest) | **GET** /admin/oauth2/auth/requests/login | Get OAuth 2.0 Login Request
[*OAuth2Api*](doc/OAuth2Api.md) | [**getOAuth2LogoutRequest**](doc/OAuth2Api.md#getoauth2logoutrequest) | **GET** /admin/oauth2/auth/requests/logout | Get OAuth 2.0 Session Logout Request
[*OAuth2Api*](doc/OAuth2Api.md) | [**getTrustedOAuth2JwtGrantIssuer**](doc/OAuth2Api.md#gettrustedoauth2jwtgrantissuer) | **GET** /admin/trust/grants/jwt-bearer/issuers/{id} | Get Trusted OAuth2 JWT Bearer Grant Type Issuer
[*OAuth2Api*](doc/OAuth2Api.md) | [**introspectOAuth2Token**](doc/OAuth2Api.md#introspectoauth2token) | **POST** /admin/oauth2/introspect | Introspect OAuth2 Access and Refresh Tokens
[*OAuth2Api*](doc/OAuth2Api.md) | [**listOAuth2Clients**](doc/OAuth2Api.md#listoauth2clients) | **GET** /admin/clients | List OAuth 2.0 Clients
[*OAuth2Api*](doc/OAuth2Api.md) | [**listOAuth2ConsentSessions**](doc/OAuth2Api.md#listoauth2consentsessions) | **GET** /admin/oauth2/auth/sessions/consent | List OAuth 2.0 Consent Sessions of a Subject
[*OAuth2Api*](doc/OAuth2Api.md) | [**listTrustedOAuth2JwtGrantIssuers**](doc/OAuth2Api.md#listtrustedoauth2jwtgrantissuers) | **GET** /admin/trust/grants/jwt-bearer/issuers | List Trusted OAuth2 JWT Bearer Grant Type Issuers
[*OAuth2Api*](doc/OAuth2Api.md) | [**oAuth2Authorize**](doc/OAuth2Api.md#oauth2authorize) | **GET** /oauth2/auth | OAuth 2.0 Authorize Endpoint
[*OAuth2Api*](doc/OAuth2Api.md) | [**oauth2TokenExchange**](doc/OAuth2Api.md#oauth2tokenexchange) | **POST** /oauth2/token | The OAuth 2.0 Token Endpoint
[*OAuth2Api*](doc/OAuth2Api.md) | [**patchOAuth2Client**](doc/OAuth2Api.md#patchoauth2client) | **PATCH** /admin/clients/{id} | Patch OAuth 2.0 Client
[*OAuth2Api*](doc/OAuth2Api.md) | [**rejectOAuth2ConsentRequest**](doc/OAuth2Api.md#rejectoauth2consentrequest) | **PUT** /admin/oauth2/auth/requests/consent/reject | Reject OAuth 2.0 Consent Request
[*OAuth2Api*](doc/OAuth2Api.md) | [**rejectOAuth2LoginRequest**](doc/OAuth2Api.md#rejectoauth2loginrequest) | **PUT** /admin/oauth2/auth/requests/login/reject | Reject OAuth 2.0 Login Request
[*OAuth2Api*](doc/OAuth2Api.md) | [**rejectOAuth2LogoutRequest**](doc/OAuth2Api.md#rejectoauth2logoutrequest) | **PUT** /admin/oauth2/auth/requests/logout/reject | Reject OAuth 2.0 Session Logout Request
[*OAuth2Api*](doc/OAuth2Api.md) | [**revokeOAuth2ConsentSessions**](doc/OAuth2Api.md#revokeoauth2consentsessions) | **DELETE** /admin/oauth2/auth/sessions/consent | Revoke OAuth 2.0 Consent Sessions of a Subject
[*OAuth2Api*](doc/OAuth2Api.md) | [**revokeOAuth2LoginSessions**](doc/OAuth2Api.md#revokeoauth2loginsessions) | **DELETE** /admin/oauth2/auth/sessions/login | Revokes All OAuth 2.0 Login Sessions of a Subject
[*OAuth2Api*](doc/OAuth2Api.md) | [**revokeOAuth2Token**](doc/OAuth2Api.md#revokeoauth2token) | **POST** /oauth2/revoke | Revoke OAuth 2.0 Access or Refresh Token
[*OAuth2Api*](doc/OAuth2Api.md) | [**setOAuth2Client**](doc/OAuth2Api.md#setoauth2client) | **PUT** /admin/clients/{id} | Set OAuth 2.0 Client
[*OAuth2Api*](doc/OAuth2Api.md) | [**setOAuth2ClientLifespans**](doc/OAuth2Api.md#setoauth2clientlifespans) | **PUT** /admin/clients/{id}/lifespans | Set OAuth2 Client Token Lifespans
[*OAuth2Api*](doc/OAuth2Api.md) | [**trustOAuth2JwtGrantIssuer**](doc/OAuth2Api.md#trustoauth2jwtgrantissuer) | **POST** /admin/trust/grants/jwt-bearer/issuers | Trust OAuth2 JWT Bearer Grant Type Issuer
[*OidcApi*](doc/OidcApi.md) | [**createOidcDynamicClient**](doc/OidcApi.md#createoidcdynamicclient) | **POST** /oauth2/register | Register OAuth2 Client using OpenID Dynamic Client Registration
[*OidcApi*](doc/OidcApi.md) | [**deleteOidcDynamicClient**](doc/OidcApi.md#deleteoidcdynamicclient) | **DELETE** /oauth2/register/{id} | Delete OAuth 2.0 Client using the OpenID Dynamic Client Registration Management Protocol
[*OidcApi*](doc/OidcApi.md) | [**discoverOidcConfiguration**](doc/OidcApi.md#discoveroidcconfiguration) | **GET** /.well-known/openid-configuration | OpenID Connect Discovery
[*OidcApi*](doc/OidcApi.md) | [**getOidcDynamicClient**](doc/OidcApi.md#getoidcdynamicclient) | **GET** /oauth2/register/{id} | Get OAuth2 Client using OpenID Dynamic Client Registration
[*OidcApi*](doc/OidcApi.md) | [**getOidcUserInfo**](doc/OidcApi.md#getoidcuserinfo) | **GET** /userinfo | OpenID Connect Userinfo
[*OidcApi*](doc/OidcApi.md) | [**revokeOidcSession**](doc/OidcApi.md#revokeoidcsession) | **GET** /oauth2/sessions/logout | OpenID Connect Front- and Back-channel Enabled Logout
[*OidcApi*](doc/OidcApi.md) | [**setOidcDynamicClient**](doc/OidcApi.md#setoidcdynamicclient) | **PUT** /oauth2/register/{id} | Set OAuth2 Client using OpenID Dynamic Client Registration
[*WellknownApi*](doc/WellknownApi.md) | [**discoverJsonWebKeys**](doc/WellknownApi.md#discoverjsonwebkeys) | **GET** /.well-known/jwks.json | Discover Well-Known JSON Web Keys


## Documentation For Models

 - [AcceptOAuth2ConsentRequest](doc/AcceptOAuth2ConsentRequest.md)
 - [AcceptOAuth2ConsentRequestSession](doc/AcceptOAuth2ConsentRequestSession.md)
 - [AcceptOAuth2LoginRequest](doc/AcceptOAuth2LoginRequest.md)
 - [CreateJsonWebKeySet](doc/CreateJsonWebKeySet.md)
 - [ErrorOAuth2](doc/ErrorOAuth2.md)
 - [GenericError](doc/GenericError.md)
 - [GetVersion200Response](doc/GetVersion200Response.md)
 - [HealthNotReadyStatus](doc/HealthNotReadyStatus.md)
 - [HealthStatus](doc/HealthStatus.md)
 - [IntrospectedOAuth2Token](doc/IntrospectedOAuth2Token.md)
 - [IsReady200Response](doc/IsReady200Response.md)
 - [IsReady503Response](doc/IsReady503Response.md)
 - [JsonPatch](doc/JsonPatch.md)
 - [JsonWebKey](doc/JsonWebKey.md)
 - [JsonWebKeySet](doc/JsonWebKeySet.md)
 - [OAuth2Client](doc/OAuth2Client.md)
 - [OAuth2ClientTokenLifespans](doc/OAuth2ClientTokenLifespans.md)
 - [OAuth2ConsentRequest](doc/OAuth2ConsentRequest.md)
 - [OAuth2ConsentRequestOpenIDConnectContext](doc/OAuth2ConsentRequestOpenIDConnectContext.md)
 - [OAuth2ConsentSession](doc/OAuth2ConsentSession.md)
 - [OAuth2ConsentSessionExpiresAt](doc/OAuth2ConsentSessionExpiresAt.md)
 - [OAuth2LoginRequest](doc/OAuth2LoginRequest.md)
 - [OAuth2LogoutRequest](doc/OAuth2LogoutRequest.md)
 - [OAuth2RedirectTo](doc/OAuth2RedirectTo.md)
 - [OAuth2TokenExchange](doc/OAuth2TokenExchange.md)
 - [OidcConfiguration](doc/OidcConfiguration.md)
 - [OidcUserInfo](doc/OidcUserInfo.md)
 - [Pagination](doc/Pagination.md)
 - [PaginationHeaders](doc/PaginationHeaders.md)
 - [RejectOAuth2Request](doc/RejectOAuth2Request.md)
 - [TokenPagination](doc/TokenPagination.md)
 - [TokenPaginationHeaders](doc/TokenPaginationHeaders.md)
 - [TokenPaginationRequestParameters](doc/TokenPaginationRequestParameters.md)
 - [TokenPaginationResponseHeaders](doc/TokenPaginationResponseHeaders.md)
 - [TrustOAuth2JwtGrantIssuer](doc/TrustOAuth2JwtGrantIssuer.md)
 - [TrustedOAuth2JwtGrantIssuer](doc/TrustedOAuth2JwtGrantIssuer.md)
 - [TrustedOAuth2JwtGrantJsonWebKey](doc/TrustedOAuth2JwtGrantJsonWebKey.md)
 - [Version](doc/Version.md)


## Documentation For Authorization


## basic

- **Type**: HTTP basic authentication

## bearer

- **Type**: HTTP basic authentication

## oauth2

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://hydra.demo.ory.sh/oauth2/auth
- **Scopes**: 
 - **offline**: A scope required when requesting refresh tokens (alias for `offline_access`)
 - **offline_access**: A scope required when requesting refresh tokens
 - **openid**: Request an OpenID Connect ID Token


## Author

hi@ory.sh

